#!/usr/bin/perl
use Crypt::Blowfish;

my $path = "/usr/local/apache/htdocs/audio";
my $pathurl = "/audio";

my $vmroot = "/var/lib/asterisk/sounds";
my $string = $ENV{QUERY_STRING};

open(KEY, "</etc/asterisk/key") || die "can't open key file: $!";
chomp(my $key = <KEY>);
close(KEY);

$key = pack("H78", $key);
my $cipher = new Crypt::Blowfish $key;

my $text;
my @blocks = unpack("a16" x (int(length($string) / 8) + 1), $string);
foreach my $block (@blocks)
{
    last unless $block;
    $text .= $cipher->decrypt(pack("H16", $block));
    $text =~ s/[^\w\s\-\,\.\/\:\?\`]//g;
}
$text =~ s/(?:\.wav)?\s*$/.wav/;

my $file = "$vmroot/$text";

if (-e $file && $text ne "")
{
    print "Content-Disposition: attachment, filename=$text\n";
    print "Content-Type: application/octet-stream\n\n";
    open(AUDIO, $file) || die "Can't open audio file: $!";

    while (<AUDIO>)
    {
        print;
    }
}
else
{
    print "Content-Type: text/html\n\n";
    print "File not found ^$file^\n";
}


