#!/usr/bin/perl

use Crypt::Blowfish;

my $string = $ENV{QUERY_STRING};

# get the blowfish key
open(KEY, "</etc/asterisk/key") || die "can't open key file: $!";
chomp(my $key = <KEY>);
close(KEY);

# get a cipher from the key
$key = pack("H78", $key);
my $cipher = new Crypt::Blowfish $key;

my $text;
my @blocks = unpack("a16" x (int(length($string) / 8) + 1), $string);
foreach my $block (@blocks)
{
	last unless $block;
	$text .= $cipher->decrypt(pack("H16", $block));
	$text =~ s/[^\w\s\@\-\,\.\/\:\?\`\"\<\>]//g;
}
$text =~ s/\s*$//;

my ($from, $to, $cid, $server_id) = split(/`/, $text);

if (!defined($from) || !defined($to))
{
	message("Unable to initiate call from '$from' to '$to'");
}


# Dialplan context
my $context = "internal";
if ($server_id)
{
	$context = "internal-$server_id";
}


# Not sure this is necessary, since we get caller-id from CP -- tcw
#
#  # get the number
#  my ($num) = ($from =~ /^(?:91|9011)?(\d+)$/);
#
#  my $from_name = $num;
#  if (-e '/etc/asterisk/unbound')
#  {
#  	my $data = `grep "Macro.*$to" /data/$server_id/etc/asterisk/fonality/external.conf`;
#  	$data ||= `grep "Macro.*$to" /data/$server_id/etc/asterisk/fonality/internal.conf`;
#  	$num = (split ',', $data)[-3];
#  }


# create a temp file -- you need to create the call file outside
# of the outgoing directory, then rename it because asterisk will
# pick up empty files WHILE you're writing to it
my $tmpfile = randstring() . ".call";

# write a call file
my $call_data = <<EOF;
Channel: $to
MaxRetries: 1
RetryTime: 60
WaitTime: 30
Context: $context
Callerid: $cid
Extension: $from
Priority: 1
EOF

open(FILE, ">>/tmp/$tmpfile");
print FILE $call_data;
close(FILE);

# Logging
open(FILE, ">>/tmp/calls");
print FILE $call_data;
close(FILE);

# Do a "mv"; this is an atomic update required to avoid Asterisk reading partial call files
rename("/tmp/$tmpfile", "/var/spool/asterisk/outgoing/$tmpfile");

message();
exit;


sub randstring
{
	my @chars = ("a".."z","A".."Z",0..9);

	my $rand;

	foreach (1 .. 12)
	{
		$rand .= $chars[int(rand(@chars))];
	}

	return $rand;
}


sub message
{
	my $message = shift;

	print << "EOF";
Content-Type: text/html

<html>
<head>
<script>
EOF

	if ($message)
	{
		print << "EOF";
alert("$message");
EOF
	}

	print << "EOF";
history.go(-1);
</script>
</head>
</html>
EOF
	exit;
}

