#!/usr/bin/perl

use strict;
use Mail::Sender;
use Crypt::Blowfish;

my $vmroot = "/var/spool/asterisk/voicemail/default/";

my $string = $ENV{QUERY_STRING};
my %fields = map { split /=/ } split /&/, $string;

open(KEY, "</etc/asterisk/key") || die "can't open key file: $!";
chomp(my $key = <KEY>);
close(KEY);

$key = pack("H78", $key);
my $cipher = new Crypt::Blowfish $key;

my @blocks = unpack("a16" x (int(length($fields{path}) / 8)+1), $fields{path});
my $text;

foreach my $block (@blocks)
{
        last unless $block;
        $text .= $cipher->decrypt(pack("H16", $block));
        $text =~ s/[^\w\s\-\,\.\/\:\?\`]//g;
}

if ($fields{email} !~ /^[^\@\s\$]+\@(?:[a-z0-9-]+\.)+[a-z]+$/i)
{
	message("Invalid email address");
}


$text =~ s/\s*$//;
my $file = "$vmroot/$text";
if (-e $file)
{
        my $sender = new Mail::Sender
        {
                smtp    => 'localhost',
                from    => '"Fonality Voicemail System" <support@fonality.com>',
        };

        $sender->OpenMultipart(
        {
                to      => $fields{email},
                subject => "Fonality Voicemail",
        });

        $sender->Body;
        $sender->SendEnc(<<"*END*");
Attached is a voicemail file that was forwarded to you by the Fonality voicemail system.

You can double click the attached file to hear it on your computer speakers.

*END*

        $sender->Attach(
        {
                file    => $file,
        });
}
else
{
	message("UNABLE TO FORWARD VOICEMAIL - PLEASE CONTACT YOUR ADMINISTRATOR");
}

if ($fields{redir})
{
        print "Location: $ENV{HTTP_REFERER}\r\n\r\n";
        exit;
}
else
{
	message("Sent voicemail message to $fields{email}");
}


sub message
{
	my $message = shift;

	print << "EOF";
Content-Type: text/html

<html>
<head>
<script>
alert("$message");
history.go(-1);
</script>
</head>
</html>
EOF

	exit;
}
