#!/usr/bin/perl
use Crypt::Blowfish;

my $path = "/usr/local/apache/htdocs/audio";
my $pathurl = "/audio";

my $vmroot = "/var/lib/asterisk/mohmp3";
my $string = $ENV{QUERY_STRING};

open(KEY, "</etc/asterisk/key") || die "can't open key file: $!";
chomp(my $key = <KEY>);
close(KEY);

$key = pack("H78", $key);
my $cipher = new Crypt::Blowfish $key;

my @blocks = unpack("a16" x (int(length($string) / 8)+1),$string);
my ($text, $server_id);
foreach my $block (@blocks)
{
	last unless $block;
	$text .= $cipher->decrypt(pack("H16", $block));
}

$text =~ s/\s*$//;
$text =~ s/[^\w\s\-\,\.\/\:\?\`]//g;
($text, $server_id) = split /`/, $text;

$text =~ s|^default/||;
my $file = "$vmroot/$text";
if ($server_id)
{
	$file = "/data/$server_id$file";
}
if (-e $file && $text ne "")
{
	$file = randpath($file);
	print "Location: $file\r\n\r\n";
}
else
{
	print "Content-Type: text/html\n\n";
	print "File not found ^$file^\n";
}


sub randpath
{
	my $mp3 = shift;
	my @chars = ("a".."z","A".."Z",0..9);

	my $url = "$pathurl/";
	my $rand;

	foreach (1 .. 12)
	{
		$rand .= $chars[int(rand(@chars))];
	}

	link($mp3, "$path/$rand.mp3");
	chmod(0755, "$path/$rand.mp3");

	return "$pathurl/$rand.mp3";
}
