#!/usr/bin/perl
use Crypt::Blowfish;

my $path = "/usr/local/apache/htdocs/audio";
my $pathurl = "/audio";

my $vmroot = "/var/spool/asterisk/monitor";
my $string = $ENV{QUERY_STRING};

open(KEY, "</etc/asterisk/key") || die "can't open key file: $!";
chomp(my $key = <KEY>);
close(KEY);

$key = pack("H78", $key);
my $cipher = new Crypt::Blowfish $key;

my ($text, $server_id);
my @blocks = unpack("a16" x (int(length($string) / 8) + 1), $string);
foreach my $block (@blocks)
{
	last unless $block;
	$text .= $cipher->decrypt(pack("H16", $block));
	$text =~ s/[^\+\w\s\-\,\.\/\:\?\`]//g;
}
$text =~ s/\.([^.]+?)\s*$/\.$1/;
($text, $server_id) = split /`/, $text;

my $file = $server_id ? "/data/$server_id$vmroot/$text" : "$vmroot/$text";
my $ext = $text;
$ext =~ s/^.*\.(\w+?)$/$1/;

if (-e $file && $text ne "")
{
	print "Location: " . randpath($file,$ext) . "\r\n\r\n";
}
else
{
	print "Content-Type: text/html\n\n";
	print "File not found ^$file^\n";
}


sub randpath
{
	my $file = shift;
	my $ext  = shift;
	
	my @chars = ("a".."z","A".."Z",0..9);

	my $url = "$pathurl/";
	my $rand;

	foreach (1 .. 12)
	{
		$rand .= $chars[int(rand(@chars))];
	}

	link($file, "$path/$rand.$ext");
	chmod(0755, "$path/$rand.$ext");

	return "$pathurl/$rand.$ext";
}
