#!/usr/bin/perl

use CGI qw/:standard/;
use CGI::Carp qw(fatalsToBrowser);

my $vmroot = "/var/lib/asterisk/sounds";
my $handle   = upload('upload_vp_name');
my $desc = param('upload_vp_desc');
my $refer = param('refer'); #$ENV{HTTP_REFERER};

# Felix Nilam - 07/22/2009
# strip any uploaded_audio, upload_error, sum and uplaod_vp_desc from referer
# which could happen when file is uploaded again after error
# also strip out remove_vp
my $vp_max_file_size = 2 * 1024 * 1024;
my @refer_params = split(/&/, $refer);
$refer = $refer_params[0];
shift(@refer_params);
for my $rp (@refer_params)
{
	if($rp !~ /^uploaded_audio|upload_error|sum|upload_vp_desc|remove_vp/)
	{
		$refer .= "&".$rp;
	}
}

if ($handle) {

	my $filename = "$handle";
	$filename = lc($filename);
	$filename =~ m|[/\\]*?([^/\\]+)$|;
	$filename = $1;
	$filename =~ s/[^a-zA-Z0-9-_\.]/_/g;
	my $noextfilename = (split(/\./, $filename))[0];

	# Felix Nilam - 07/22/2009
	# check that filename is of type .wav
	if($noextfilename eq '')
	{
		$noextfilename = 'none';
	}
	my @fl = split(/\./, $filename);
	my $error = '';
	if($fl[1] ne 'wav')
	{
		$error = 'Your file must be of type .wav';
	}
	elsif($fl[0] eq '')
	{
		$error = '2';
	}

	my $sum = 0;
	my $buffer;

	if($error eq '')
	{
		my $in_loop = 0;
		open(AUDIO, ">$vmroot/$filename") || die("Can't write to $vmroot/$filename: $!");
		binmode AUDIO;

		# Felix Nilam - 07/22/2009
		# add error checking on the uploaded file
		while (read($handle, $buffer, 1024))
		{
			$in_loop = 1;
			$sum += length($buffer);
			if ($sum > $vp_max_file_size)
			{
				$error = 'File too large. Max size is: '. int($vp_max_file_size/1024/1024). 'MB.';
				last;
			}
			print AUDIO $buffer;
		}
		close(AUDIO);

		# check for empty file
		if(!$in_loop)
		{
			$error = 'File is empty.';
		}
		elsif($error eq '')
		{
			# get the file type and verify
			my $filetype = `/usr/bin/file $vmroot/$filename`;
			if ($filetype !~ /PCM, 16 bit, mono 8000 Hz/)
			{
				$error = 'File type must be: PCM, 16-bit, mono 8000 Hz (8 KHz).';
			}
			else
			{
				# Felix Nilam - 08/04/2009
				# transcode the file
				my @args = ("/usr/bin/perl","/var/adm/bin/transcode.pl","$vmroot/$filename");
				system(@args);
				$filename =~ s/(.)/"%" . unpack("H2", $1)/eg;
			}
		}
	}

	if($error ne '')
	{
		$error =~ s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg;
	}

	$refer .= "&uploaded_audio=$noextfilename&sum=$sum&upload_vp_desc=$desc&upload_error=$error";
}

print "Location: $refer\r\n\r\n";

