#!/usr/bin/perl
use Crypt::Blowfish;

my $path = "/usr/local/apache/htdocs/audio";
my $pathurl = "/audio";

$vmroot = "/var/spool/asterisk/voicemail/default";

$string = $ENV{QUERY_STRING};
$string =~ s/\.wav//g;

open(KEY, "</etc/asterisk/key") || die "can't open key file: $!";
chomp(my $key = <KEY>);
close(KEY);

$key = pack("H78", $key);
my $cipher = new Crypt::Blowfish $key;

my @blocks = unpack("a16" x (int(length($string) / 8)+1),$string);
my $text;
foreach my $block (@blocks)
{
   last unless $block;
   $text .= $cipher->decrypt(pack("H16", $block));
	$text =~ s/[^\w\s\-\,\.\/\:\?\`]//g;
}
$text =~ s/\s*$//;

if ($text =~ /^Delete`/){   # delete the message
   ($action, $redirect, $file_loc)  = split(/`/, $text);
   $redirect = $ENV{HTTP_REFERER};
	$file = "$vmroot/$file_loc";
	
	if (-e $file && $text ne ""){
	    $filetxt = $file;
		 $filetxt =~ s/\.wav/\.txt/;
		 if (unlink $file){  #remove the wav file
	        if (unlink $filetxt){ # remove the txt file
		 	 		print "Location: $redirect\n\n";

		 		} else {
		 	 		print "Content-type: text/html\n\n";
		    		print "Can not remove $filetxt\n";
		 		}
		 } else {
		 	print "Content-type: text/html\n\n";
			print "Can not remove $file\n";
		}

	} else {
		print "Content-type: text/html\n";
		print "Can not find file $file\n";
	}
}
# move the message
elsif ($text =~ /^(?:Save|Move)`/)
{
	my ($action, $redirect, $file_loc, $to) = split(/`/, $text);
        $redirect = $ENV{HTTP_REFERER};
	my $file = "$vmroot/$file_loc";

	if (-e $file)
	{
		my $filetxt = $file;
		$filetxt =~ s/\.wav/\.txt/;

		my $newfile = $file;
		my $newfiletxt = $filetxt;

		$newfile    =~ s| ^ (.*/) [^/]+ (/[^/]+\.wav) $ |$1$to$2|x;
		$newfiletxt =~ s| ^ (.*/) [^/]+ (/[^/]+\.txt) $ |$1$to$2|x;

		unless (-e $1 . $to)
		{
			mkdir($1 . $to, 0755);
		}
		rename($file, $newfile);
		rename($filetxt, $newfiletxt);

 		print "Location: $redirect\n\n";

	}
	else
	{
		print "Content-type: text/html\n";
		print "Can not find file $file\n";
	}
}
# play the message
else
{
	my $file = "$vmroot/$text";

	if (-e $file && $text ne "")
	{
		print "Location: " . randpath($file) . "\r\n\r\n";
	}
	else
	{
		print "Content-Type: text/html\n\n";
		print "File not found ^$file^\n";
	}
}


sub randpath
{
	my $wav = shift;
	my @chars = ("a".."z","A".."Z",0..9);

	my $url = "$pathurl/";
	my $rand;

	foreach (1 .. 12)
	{
		$rand .= $chars[int(rand(@chars))];
	}

	link($wav, "$path/$rand.wav");
	chmod(0755, "$path/$rand.wav");

	return "$pathurl/$rand.wav";
}
